#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <sys/time.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>
#include <regex.h>
#include <errno.h>
#include "../include/gtkunilist.h"
//for ftp
#include <netdb.h>
#include <sys/socket.h>

//struct settings{
//	gchar * option; int value; gchar *comment;};
struct VFS_applications{
	gpointer name; 		// application viewer name
	gpointer command;	// application viewer
	guint terminal;		// run in terminal?
};
struct VFS_keys{
	gpointer mime; 		// application mime
	gpointer icon;		// application icon filename
	gpointer name;		// application viewer name
};
struct VFS_mime{
	gpointer regex; 	// application regex
	gpointer icon;		// application icon filename
	gpointer name;		// application viewer name
	guint terminal;		// run in terminal?
};

//main functions
void destroy();void preview();
void mainrefresh();
//files, dirs functions
GList* getapps();GList* getkeys(GList *appsarr);GList* getmimes(GList *appsarr, GList *keysarr);
VFS_mime* checkregex(gchar *name);
void copyfiles();void renamefiles();void deletefiles();
gint removefile(gchar *);
gint copy(gchar *, gchar *);gint copyfile(gchar *, gchar *, gint begin, gint cur, gint count);
void operationfiles(GArray *, gint op);
void makelink();void makesymlink();
void makedir();void volumelabel();
void edit();void view();void execute(gchar *filename);
gchar * escapefilename(gchar *filename);
void attributes();
gfloat calcdirsize(gchar *dir);
//network
void ftpconnect();
//visual functions
void verticalarrangment();
void messageboxinfo(gchar*);void messageboxerror(gchar*);
gint messageboxinput(gchar* title, gchar *label);
gint messageboxyesno(gchar*);
//settings
void getsettings();void savesettings();void editsettings();void options();
//other functions
gchar *generatestatus (GtkUniList *list);
void goleftdir ();void gorightdir ();
gchar * godir (gchar *dir,GArray *, GtkWidget *, gint hidden, gint backup, gchar *defaultfile,gint showicons);
void updatecommandlineframe();void updatestatusbar();
void rereadsource();void rereadsourceall();
void targetsource();void sourcetarget();
void changeleft();void changeright();void changetoolbar();
void arrangeleft();void arrangeright();
gint gtk_unilist_set_focus();
void gtk_combo_popup_list(GtkWidget * combo);
gchar * format_size(gfloat size);
gchar * format_number(gchar *size);
gchar * format_time(time_t);
gchar * format_atr(mode_t);
gchar * geticon(gchar *);
//menu
GtkItemFactory * menu(GtkWidget *,GtkWidget *, GtkAccelGroup *);
void about();void gohome();
