#include "../include/main.h"
#define	EMPTY_LIST_HEIGHT	(15)


//functions taken from original gtk2.0 gtkcombo.c
static void
gtk_combo_get_pos (GtkCombo * combo, gint * x, gint * y, gint * height, gint * width)
{
  GtkBin *popwin;
  GtkWidget *widget;
  GtkScrolledWindow *popup;
  
  gint real_height;
  GtkRequisition list_requisition;
  gboolean show_hscroll = FALSE;
  gboolean show_vscroll = FALSE;
  gint avail_height;
  gint min_height;
  gint alloc_width;
  gint work_height;
  gint old_height;
  gint old_width;
  
  widget = GTK_WIDGET (combo);
  popup  = GTK_SCROLLED_WINDOW (combo->popup);
  popwin = GTK_BIN (combo->popwin);
  
  gdk_window_get_origin (combo->entry->window, x, y);
  real_height = MIN (combo->entry->requisition.height, 
		     combo->entry->allocation.height);
  *y += real_height;
  avail_height = gdk_screen_height () - *y;
  
  gtk_widget_size_request (combo->list, &list_requisition);
  min_height = MIN (list_requisition.height, 
		    popup->vscrollbar->requisition.height);
  if (!GTK_LIST (combo->list)->children)
    list_requisition.height += EMPTY_LIST_HEIGHT;
  
  alloc_width = (widget->allocation.width -
		 2 * popwin->child->style->xthickness -
		 2 * GTK_CONTAINER (popwin->child)->border_width -
		 2 * GTK_CONTAINER (combo->popup)->border_width -
		 2 * GTK_CONTAINER (GTK_BIN (popup)->child)->border_width - 
		 2 * GTK_BIN (popup)->child->style->xthickness);
  
  work_height = (2 * popwin->child->style->ythickness +
		 2 * GTK_CONTAINER (popwin->child)->border_width +
		 2 * GTK_CONTAINER (combo->popup)->border_width +
		 2 * GTK_CONTAINER (GTK_BIN (popup)->child)->border_width +
		 2 * GTK_BIN (popup)->child->style->xthickness);
  
  do 
    {
      old_width = alloc_width;
      old_height = work_height;
      
      if (!show_hscroll &&
	  alloc_width < list_requisition.width)
	{
	  work_height += (popup->hscrollbar->requisition.height +
			  GTK_SCROLLED_WINDOW_GET_CLASS (combo->popup)->scrollbar_spacing);
	  show_hscroll = TRUE;
	}
      if (!show_vscroll && 
	  work_height + list_requisition.height > avail_height)
	{
	  if (work_height + min_height > avail_height && 
	      *y - real_height > avail_height)
	    {
	      *y -= (work_height + list_requisition.height + real_height);
	      break;
	    }
	  alloc_width -= (popup->vscrollbar->requisition.width +
			  GTK_SCROLLED_WINDOW_GET_CLASS (combo->popup)->scrollbar_spacing);
	  show_vscroll = TRUE;
	}
    } while (old_width != alloc_width || old_height != work_height);
  
  *width = widget->allocation.width;
  if (show_vscroll)
    *height = avail_height;
  else
    *height = work_height + list_requisition.height;
  
  if (*x < 0)
    *x = 0;
}


void gtk_combo_popup_list (GtkWidget * combowidget)
{
	GtkCombo * combo = (GtkCombo *) combowidget;
  gint height, width, x, y;
  gint old_width, old_height;

  old_width = combo->popwin->allocation.width;
  old_height  = combo->popwin->allocation.height;

  gtk_combo_get_pos (combo, &x, &y, &height, &width);
  /* workaround for gtk_scrolled_window_size_allocate bug */
  if (old_width != width || old_height != height)
    {
      gtk_widget_hide (GTK_SCROLLED_WINDOW (combo->popup)->hscrollbar);
      gtk_widget_hide (GTK_SCROLLED_WINDOW (combo->popup)->vscrollbar);
    }

  gtk_window_move (GTK_WINDOW (combo->popwin), x, y);
  gtk_widget_set_usize (combo->popwin, width, height);
  gtk_widget_show (combo->popwin);

  gtk_widget_grab_focus (combo->popwin);
  gtk_grab_add(combo->popwin);
}

gchar * geticon(gchar * file){
static gchar *stringvalue="<stringvalue>";
static gchar buffer[300];gchar *found, *theme="default";
static gchar * nautilusthemedir = "/usr/share/pixmaps/nautilus/";
static gchar * nautilusconffile = g_strconcat(g_get_home_dir(),
					"/.gconf/desktop/gnome/file_views/%gconf.xml",NULL);
	FILE *conffile = fopen(nautilusconffile, "r");
	if (conffile != NULL){
	  if (fgets (buffer,299,conffile)!=NULL){
		if (fgets (buffer,299,conffile)!=NULL){
		 found = strstr(buffer,"icon_theme");
		 if (found != NULL){ found = strstr(found,stringvalue);
			 theme=found+strlen(stringvalue);
			 found = strstr(theme,"</");found[0]=0; 
		}}}fclose(conffile);
	}
	sprintf(buffer,"%s%s/%s",nautilusthemedir,theme,file);
	if (g_file_test(buffer,G_FILE_TEST_EXISTS)) return buffer;
	sprintf(buffer,"%s%s/%s\.png",nautilusthemedir,theme,file);
	if (g_file_test(buffer,G_FILE_TEST_EXISTS)) return buffer;
	sprintf(buffer,"%s%s/%s",nautilusthemedir,"default",file);
	if (g_file_test(buffer,G_FILE_TEST_EXISTS)) return buffer;
	sprintf(buffer,"%s%s/%s\.png",nautilusthemedir,"default",file);
	if (g_file_test(buffer,G_FILE_TEST_EXISTS)) return buffer;
	sprintf(buffer,"%s%s/%s",nautilusthemedir,"Bluecurve",file);
	if (g_file_test(buffer,G_FILE_TEST_EXISTS)) return buffer;
	sprintf(buffer,"%s%s/%s\.png",nautilusthemedir,"Bluecurve",file);
	if (g_file_test(buffer,G_FILE_TEST_EXISTS)) return buffer;
	return file;
}
#define LINE_LENGTH 200
GList * getapps(){guint cur;
	struct VFS_applications *data;
	GList *appsarr=NULL;
	gchar line[256];
	gchar *found, *ext, *appname, *filename, *name;
	gchar buffer[300], *command;
	gchar *dir="/usr/share/application-registry";
	regex_t compiled;
	gint terminal,res=regcomp(&compiled,"\.applications$",NULL);
	FILE *file;
	GDir *dirhandle;
	gchar *errstr = "Error\n";
	GError *error;
//	gpointer data;
	
	error = g_error_new(1,0,errstr);
	dirhandle = g_dir_open(dir,0, &error);
	(const gchar *)name = g_dir_read_name (dirhandle);
	while (name != NULL){
	 if (0==regexec(&compiled,name,0,NULL,0)){
		filename=g_strdup_printf("%s/%s",dir,name);
		file = fopen(filename, "r");
		if (file!=NULL){appname=command=NULL;terminal=FALSE;
		  while (fgets(line,200,file)!=NULL){//g_print("%s",line);
			if (line[0]!='#'){found=strstr(line,"\n");if (found!=NULL)found[0]=0;
				found = strchr(line,'=');
				if (found!=NULL){ found[0] = 0;found++;
				  if (appname!=NULL){
					  if (strstr(line,"requires_terminal")!=NULL)
						  if (strstr(found,"true")!=NULL) terminal=TRUE;
					  if (strstr(line,"command")!=NULL){g_free(command);command=g_strdup(found);}
//						g_print("%s===%s\n",line, found);
//						g_print("%s:%s:%s\n",appname,command,terminal);
				}} else {
					if (line[0]>' ') {
						if (command!=NULL && appname!=NULL){data=g_new(VFS_applications,1);
							data->name=appname;data->command=command;data->terminal=terminal;
							appsarr=g_list_append(appsarr,data);appname=command=NULL;
						}
						g_free(appname);g_free(command);terminal=FALSE;appname=command=NULL;
						appname=g_strdup(line);
				}}
			}
		  }fclose(file);if (command!=NULL && appname!=NULL){data=g_new(VFS_applications,1);
							data->name=appname;data->command=command;data->terminal=terminal;
							appsarr=g_list_append(appsarr,data);appname=command=NULL;
						}
		} else g_printerr("File %s not found !!!\n", filename);
		g_free(filename);//printf("%s\n",name);
	}(const gchar *)name = g_dir_read_name (dirhandle);}g_dir_close(dirhandle);
	return appsarr;
}
GList* getkeys(GList *appsarr){guint cur;
	struct VFS_keys *data;
	GList *keysarr=NULL;
	gchar line[256];
	gchar *found, *ext, *regexname=NULL, *mimename, *appname, *iconname, *filename, *name;
	gchar buffer[300];
	gchar *dir="/usr/share/mime-info";
	regex_t compiled;
	gint res=regcomp(&compiled,"\.keys$",NULL);
	FILE *file;
	GDir *dirhandle;
	gchar *errstr = "Error\n";
	GError *error;
	
	error = g_error_new(1,0,errstr);
	dirhandle = g_dir_open(dir,0, &error);
	(const gchar *)name = g_dir_read_name (dirhandle);
	while (name != NULL){
	 if (0==regexec(&compiled,name,0,NULL,0)){
		filename=g_strdup_printf("%s/%s",dir,name);
		file = fopen(filename, "r");
		if (file!=NULL){mimename=appname=iconname=NULL;
		  while (fgets(line,200,file)!=NULL){//g_print("%s",line);
			if (line[0]!='#'){found=strstr(line,"\n");if (found!=NULL)found[0]=0;
				found = strchr(line,'=');
				if (found!=NULL){ found[0] = 0;found++;
				  if (mimename!=NULL){
					  if (strstr(line,"icon_filename")!=NULL){g_free(iconname);iconname=g_strdup(found);}
					  if (strstr(line,"icon-filename")!=NULL){g_free(iconname);iconname=g_strdup(found);}
					  if (strstr(line,"default_application_id")!=NULL){g_free(appname);appname=g_strdup(found);}
					  if (strstr(line,"short_list_application_ids_for_novice")!=NULL){g_free(appname);ext=found;
						  found=strchr(found,',');if (found!=NULL)found[0]=0;
						  appname=g_strdup(ext);
					  }
					  if (strstr(line,"open")!=NULL){g_free(appname);ext=found;
						  found=strstr(found,"%f");if (found!=NULL)found[0]=0;
						  appname=g_strdup(ext);
					  }
				}} else {
					if (line[0]>' ') {
						if (mimename!=NULL && (iconname!=NULL || appname!=NULL)){data=g_new(VFS_keys,1);
							data->name=appname;data->icon=iconname;data->mime=mimename;
							keysarr=g_list_append(keysarr,data);appname=iconname=mimename=NULL;
						}
						g_free(appname);g_free(mimename);g_free(iconname);
						mimename=appname=iconname=NULL;
						found=strchr(line,':');if (found!=NULL)found[0]=0;
						mimename=g_strdup(line);
				}}
			}
		  }fclose(file);if (mimename!=NULL && (iconname!=NULL || appname!=NULL)){data=g_new(VFS_keys,1);
							data->name=appname;data->icon=iconname;data->mime=mimename;
							keysarr=g_list_append(keysarr,data);appname=iconname=mimename=NULL;
						}

		} else g_printerr("File %s not found !!!\n", filename);
		g_free(filename);//printf("%s\n",name);
	}(const gchar *)name = g_dir_read_name (dirhandle);}g_dir_close(dirhandle);
	return keysarr;
}
VFS_mime* getmimeinfo(GList *appsarr, GList *keysarr, gchar *mime, gchar *regex){
	VFS_mime *res;VFS_keys *keysdata;VFS_applications *appsdata;
	res=g_new(VFS_mime,1);
	res->regex=g_strdup(regex);res->icon=res->name=NULL;res->terminal=FALSE;
	guint i,j,found;
	gchar *icon;
	found=FALSE;i=0;
	icon=strchr(mime,'regex');
	while (i<g_list_length(keysarr) && found==FALSE){
		keysdata=(VFS_keys*)g_list_nth_data(keysarr,i);
		if (strcasecmp((gchar *)keysdata->mime,mime)==0){found=TRUE;
			res->icon=keysdata->icon;res->name=keysdata->name;
		}
		i++;
	}
		
	if (res->name!=NULL){j=0;found=FALSE;
	  while (j<g_list_length(appsarr) && found==FALSE){
		appsdata=(VFS_applications*)g_list_nth_data(appsarr,j);
		if (strcasecmp((gchar *)appsdata->name,(gchar *)res->name)==0){found=TRUE;
//			if (res->icon==NULL) res->icon=appsdata->icon;
			res->name=appsdata->command;res->terminal=appsdata->terminal;
		}
		j++;
	}if (res->icon==NULL) {icon=strchr(mime,'/');
		if (icon!=NULL){ res->icon=g_strdup_printf("gnome-%s",mime);
			icon=strchr((gchar *)res->icon,'/');icon[0]='-';
			}}
	}
	
//	g_print("%s:%s:%s:%d\n",(gchar *)res->regex,(gchar *)res->icon,(gchar *)res->name,res->terminal);
//	g_print("Count:%d:%d\n",g_list_length(appsarr),g_list_length(keysarr));
	return res;
}
GList* getmimes(GList *appsarr, GList *keysarr){guint cur;
	GList *mimearr=NULL;
	gchar line[256];
	gchar *found, *ext, *regexname=NULL, *mimename, *iconname, *appname, *filename, *name;
	gchar buffer[300];
	gchar *dir="/usr/share/mime-info";
	regex_t compiled;
	gint res=regcomp(&compiled,"\.mime$",NULL);
	FILE *file;
	GDir *dirhandle;
	gchar *errstr = "Error\n";
	GError *error;
	guint terminal=FALSE;
	
	error = g_error_new(1,0,errstr);
	dirhandle = g_dir_open(dir,0, &error);
	(const gchar *)name = g_dir_read_name (dirhandle);
	while (name != NULL){
	 if (0==regexec(&compiled,name,0,NULL,0)){
		filename=g_strdup_printf("%s/%s",dir,name);
		file = fopen(filename, "r");
		if (file!=NULL){
//		  res=fgets(line,LINE_LENGTH,file);
		  while (fgets(line,LINE_LENGTH,file)!=NULL){
			if (line[0]!='#'){found=strstr(line,"\n");if (found!=NULL)found[0]=0;
				found = strchr(line,':');
				if (found!=NULL){ found[0] = 0;
				 if (mimename!=NULL){ext=found+1;while (ext[0]==' ')ext++;
					found=strstr(line,"regex");
					if (found!=NULL){//printf("%s -> %s\n",mimename,ext);
						g_free(regexname);regexname=g_strdup(ext);//checkregex(regexname);
						mimearr=g_list_append(mimearr,getmimeinfo(appsarr, keysarr, mimename, regexname));
					}else {found=strstr(line,"ext");
					  if (found!=NULL){
						  while (ext[0]!=0){while (ext[0]==' ')ext++;cur=0;
							while (ext[0]!=' ' && ext[0]!=0){line[cur]=ext[0];cur++;ext++;}line[cur]=0;
							g_free(regexname);regexname=g_strdup_printf("\\.%s\$",line);
//							printf("%s -> %s\n",mimename,regexname);
							mimearr=g_list_append(mimearr,getmimeinfo(appsarr, keysarr, mimename, regexname));
							//checkregex(regexname);
				}}}}} else {found = strstr(line,"/");
					if (found!=NULL) {g_free(mimename);mimename=g_strdup(line);}
				}
				found = strstr(line,"/");if (found!=NULL) found[0] = 0;
			  found = strchr(line,'=');
			}
		  }fclose(file);
		} else g_printerr("File %s not found !!!\n", filename);
		g_free(filename);//printf("%s\n",name);
	}(const gchar *)name = g_dir_read_name (dirhandle);}g_dir_close(dirhandle);
	return mimearr;
}

