#include <gtk/gtk.h>
#include "../include/main.h"

/*
void menu(GtkWidget *mainwindow,GtkWidget *main, GtkAccelGroup *accel_group){
	GtkWidget *menubar = gtk_menu_bar_new();
	accel_group = gtk_accel_group_new();

	GtkWidget *file = gtk_menu_item_new_with_mnemonic("_File");
	GtkWidget *menu = gtk_menu_new();
	
	GtkWidget *help = gtk_image_menu_item_new_from_stock(GTK_STOCK_QUIT, NULL);
//	gtk_menu_item_set_accel_path(GTK_MENU_ITEM(help),"<control>/Q");
	gtk_menu_bar_append(GTK_MENU_BAR(menubar),file);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(file),menu);
	gtk_menu_append(GTK_MENU(menu),help);
	gtk_accel_group_connect(accel_group,'Q',GDK_MOD1_MASK,GTK_ACCEL_VISIBLE,(GClosure *)destroy);
//	gtk_menu_bar_append(GTK_MENU_BAR(menubar),help);
	
	gtk_box_pack_start (GTK_BOX (main), menubar, FALSE, TRUE, 0);
	
}
*/
static void print_hello()
{
  g_message ("Hello, World!\n");
}
	/* This is the GtkItemFactoryEntry structure used to generate new menus.
   Item 1: The menu path. The letter after the underscore indicates an
           accelerator key once the menu is open.
   Item 2: The accelerator key for the entry
   Item 3: The callback function.
   Item 4: The callback action.  This changes the parameters with
           which the function is called.  The default is 0.
   Item 5: The item type, used to define what kind of an item it is.
           Here are the possible values:

           NULL               -> "<Item>"
           ""                 -> "<Item>"
           "<Title>"          -> create a title item
           "<Item>"           -> create a simple item
           "<CheckItem>"      -> create a check item
           "<ToggleItem>"     -> create a toggle item
           "<RadioItem>"      -> create a radio item
           <path>             -> path of a radio item to link against
           "<Separator>"      -> create a separator
           "<Branch>"         -> create an item to hold sub items (optional)
           "<LastBranch>"     -> create a right justified branch 
           "<StockItem>"      -> StockItem
           "<ImageItem>"      -> Item
*/


static GtkItemFactoryEntry menu_items[] = {
	{"/_File", NULL, NULL, 0, "<Branch>" },
	{ "/File/_Attributes", NULL, GtkItemFactoryCallback(attributes), 0, NULL },
	{ "/File/filesep0", NULL, NULL, 0, "<Separator>" },
	{ "/File/Change L_eft", "<alt>F1", GtkItemFactoryCallback(changeleft), 0, NULL },
	{ "/File/Change _Right", "<alt>F2", GtkItemFactoryCallback(changeright), 0, NULL },
	{ "/File/filesep1", NULL, NULL, 0, "<Separator>" },
	{ "/File/Make _Link", NULL, GtkItemFactoryCallback(makelink), 0, NULL },
	{ "/File/Make _Symlink", NULL, GtkItemFactoryCallback(makesymlink), 0, NULL },
	{ "/File/filesep2", NULL, NULL, 0, "<Separator>" },
	{ "/File/_Copy File(s)", "F5", GtkItemFactoryCallback(copyfiles), 0, NULL },
	{ "/File/_Move(Rename) File(s)", "F6", GtkItemFactoryCallback(renamefiles), 0, NULL },
	{ "/File/_Delete File(s)", "F8", GtkItemFactoryCallback(deletefiles), 0, NULL },
	{ "/File/filesep3", NULL, NULL, 0, "<Separator>" },
	{ "/File/_Quit", "<control>Q", GtkItemFactoryCallback(destroy), 0, "<StockItem>", GTK_STOCK_QUIT },
	{"/_Commands", NULL, NULL, 0, "<Branch>" },
	{ "/Commands/View File", "F3", GtkItemFactoryCallback(view), 0, NULL },
	{ "/Commands/Edit File", "F4", GtkItemFactoryCallback(edit), 0, NULL },
	{ "/Commands/comsep1", NULL, NULL, 0, "<Separator>" },
	{ "/Commands/Create _Directory", "F7", GtkItemFactoryCallback(makedir), 0, NULL },
	{ "/Commands/comsep2", NULL, NULL, 0, "<Separator>" },
	{ "/Commands/Go _Home", NULL, GtkItemFactoryCallback(gohome), 0, "<StockItem>", GTK_STOCK_HOME },
	{ "/Commands/Volume Label...", NULL, GtkItemFactoryCallback(volumelabel), 0, NULL },
	{ "/Commands/comsep3", NULL, NULL, 0, "<Separator>" },
	{ "/Commands/Source<=_>Target", "<control>U", GtkItemFactoryCallback(sourcetarget), 0, NULL },
	{ "/Commands/Target_=Source", NULL, GtkItemFactoryCallback(targetsource), 0, NULL },
	{"/_Network", NULL, NULL, 0, "<Branch>" },
	{ "/Network/FTP _List", NULL, GtkItemFactoryCallback(preview), 0, "<StockItem>", GTK_STOCK_INDEX },
	{ "/Network/FTP _Connect", "<control>F", GtkItemFactoryCallback(ftpconnect), 0, "<StockItem>", GTK_STOCK_JUMP_TO },
	//{ "/Network/sep1", NULL, NULL, 0, "<Separator>" },
	//{ "/Network/_Network Neighborhood", NULL, GtkItemFactoryCallback(preview), 0, NULL },
	{"/_Show", NULL, NULL, 0, "<Branch>" },
//	{ "/Show/Show Directory S_izes", NULL, GtkItemFactoryCallback(preview), 0, "<CheckItem>" },
//	{ "/Show/showsep0", NULL, NULL, 0, "<Separator>" },
	{"/Show/_Left Arrange Items", NULL, NULL, 0, "<Branch>" },
	{ "/Show/Left Arrange Items/_Directory first", NULL, GtkItemFactoryCallback(arrangeleft), 0, "<CheckItem>" },
	{ "/Show/Left Arrange Items/sep1", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Left Arrange Items/By _Name", NULL, GtkItemFactoryCallback(arrangeleft), 0, "<RadioItem>" },
	{ "/Show/Left Arrange Items/By _Size", NULL, GtkItemFactoryCallback(arrangeleft), 0, "/Show/Left Arrange Items/By Name" },
	{ "/Show/Left Arrange Items/By _Time", NULL, GtkItemFactoryCallback(arrangeleft), 0, "/Show/Left Arrange Items/By Name" },
	{ "/Show/Left Arrange Items/By E_xtension", NULL, GtkItemFactoryCallback(arrangeleft), 0, "/Show/Left Arrange Items/By Name" },
	{ "/Show/Left Arrange Items/_Unsorted", NULL, GtkItemFactoryCallback(arrangeleft), 0, "/Show/Left Arrange Items/By Name" },
	{ "/Show/Left Arrange Items/sep2", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Left Arrange Items/Case Sensi_tive", NULL, GtkItemFactoryCallback(arrangeleft), 0, "<CheckItem>" },
	{ "/Show/Left Arrange Items/sep3", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Left Arrange Items/_Reversed Order", NULL, GtkItemFactoryCallback(arrangeleft), 0, "<CheckItem>" },
	{ "/Show/Left Arrange Items/sep4", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Left Arrange Items/Show _Backup", NULL, GtkItemFactoryCallback(arrangeleft), 0, "<CheckItem>" },
	{ "/Show/Left Arrange Items/Show _Hidden", NULL, GtkItemFactoryCallback(arrangeleft), 0, "<CheckItem>" },
	{"/Show/_Right Arrange Items", NULL, NULL, 0, "<Branch>" },
	{ "/Show/Right Arrange Items/_Directory first", NULL, GtkItemFactoryCallback(arrangeright), 0, "<CheckItem>" },
	{ "/Show/Right Arrange Items/sep1", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Right Arrange Items/By _Name", NULL, GtkItemFactoryCallback(arrangeright), 0, "<RadioItem>" },
	{ "/Show/Right Arrange Items/By _Size", NULL, GtkItemFactoryCallback(arrangeright), 0, "/Show/Right Arrange Items/By Name" },
	{ "/Show/Right Arrange Items/By _Time", NULL, GtkItemFactoryCallback(arrangeright), 0, "/Show/Right Arrange Items/By Name" },
	{ "/Show/Right Arrange Items/By E_xtension", NULL, GtkItemFactoryCallback(arrangeright), 0, "/Show/Right Arrange Items/By Name" },
	{ "/Show/Right Arrange Items/_Unsorted", NULL, GtkItemFactoryCallback(arrangeright), 0, "/Show/Right Arrange Items/By Name" },
	{ "/Show/Right Arrange Items/sep2", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Right Arrange Items/Case Sensi_tive", NULL, GtkItemFactoryCallback(arrangeright), 0, "<CheckItem>" },
	{ "/Show/Right Arrange Items/sep3", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Right Arrange Items/_Reversed Order", NULL, GtkItemFactoryCallback(arrangeright), 0, "<CheckItem>" },
	{ "/Show/Right Arrange Items/sep4", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Right Arrange Items/Show _Backup", NULL, GtkItemFactoryCallback(arrangeright), 0, "<CheckItem>" },
	{ "/Show/Right Arrange Items/Show _Hidden", NULL, GtkItemFactoryCallback(arrangeright), 0, "<CheckItem>" },
	{ "/Show/showsep1", NULL, NULL, 0, "<Separator>" },
	{ "/Show/_Toolbar", NULL, NULL, 0, "<Branch>" },
	{ "/Show/Toolbar/_Show Icons and Text", NULL, GtkItemFactoryCallback(changetoolbar), 0, "<RadioItem>" },
	{ "/Show/Toolbar/Show _Icons only", NULL, GtkItemFactoryCallback(changetoolbar), 0, "/Show/Toolbar/Show Icons and Text" },
	{ "/Show/Toolbar/Show _Text only", NULL, GtkItemFactoryCallback(changetoolbar), 0, "/Show/Toolbar/Show Icons and Text" },
	{ "/Show/Toolbar/_Hide Toolbar", NULL, GtkItemFactoryCallback(changetoolbar), 0, "/Show/Toolbar/Show Icons and Text" },
	{ "/Show/showsep2", NULL, NULL, 0, "<Separator>" },
	{ "/Show/Vertical Arrangment", NULL, GtkItemFactoryCallback(verticalarrangment), 0, "<CheckItem>" },
	{ "/Show/R_eread Source", "<control>R", GtkItemFactoryCallback(rereadsource), 0, "<StockItem>", GTK_STOCK_REFRESH },
	{"/C_onfiguration", NULL, NULL, 0, "<Branch>" },
	{ "/Configuration/_Options", NULL, GtkItemFactoryCallback(options), 0, "<StockItem>", GTK_STOCK_PREFERENCES},
	{ "/Configuration/confsep1", NULL, NULL, 0, "<Separator>" },
	{ "/Configuration/_Load saved settings", NULL, GtkItemFactoryCallback(getsettings), 0, "<StockItem>", GTK_STOCK_OPEN},
	{ "/Configuration/_Save settings", NULL, GtkItemFactoryCallback(savesettings), 0, "<StockItem>", GTK_STOCK_SAVE},
	{ "/Configuration/confsep2", NULL, NULL, 0, "<Separator>" },
	{ "/Configuration/_Edit settings file", NULL, GtkItemFactoryCallback(editsettings), 0, NULL },
	{ "/_Help",         NULL,         NULL, 0, "<LastBranch>" },
	{ "/_Help/_About",   NULL,         GtkItemFactoryCallback(about), 0, NULL }
};


GtkItemFactory * menu(GtkWidget *mainwindow,GtkWidget *main, GtkAccelGroup *accel_group){
	GtkWidget *menubar;
	GtkItemFactory *item_factory;
	gint i,nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);
	static GtkStockItem *stockitem;
//	gtk_stock_lookup();
	
	accel_group = gtk_accel_group_new();
	item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>", accel_group);
	gtk_item_factory_create_items (item_factory, nmenu_items, menu_items, NULL);
	gtk_window_add_accel_group (GTK_WINDOW (mainwindow), accel_group);
	
	if (menubar){menubar = gtk_item_factory_get_widget (item_factory, "<main>");}

//	for (i=0;i<nmenu_items;i++){
//		g_print("%d=%d\n",i,nmenu_items);
//		if (menu_items[i].item_type!=NULL && menu_items[i].extra_data!=NULL)
//		if (strcmp(menu_items[i].item_type,"<StockItem>")==0)
//		if(gtk_stock_lookup((gchar *)menu_items[i].extra_data,stockitem)) {
//			gtk_label_set_text_with_mnemonic(GTK_LABEL(gtk_item_factory_get_widget(item_factory,menu_items[i].path)->menu_item),g_strdup(stockitem->label));
//			g_print("%s\n",stockitem->label);
//	}}
	gtk_box_pack_start (GTK_BOX (main), menubar, FALSE, TRUE, 0);

	return item_factory;
}
//*/
